/***************************************************************************
 *   Copyright (C) 2003 by jalal (Tim Pushman)                             *
 *   jalal@gnomedia.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef _KREFTY_H_
#define _KREFTY_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapplication.h>
#include <kparts/mainwindow.h>

// TODO: do we need the statusbar?

class KToggleAction;
class KreftySheetList;
class KreftyPart;

/**
 * This is the application "Shell".  It has a menubar, toolbar, and
 * statusbar but relies on the "Part" to do all the real work.
 *
 * @short Application Shell
 * @author jalal <jalal@supergnome>
 * @version 0.2
 */
class Krefty : public KParts::MainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    Krefty();

    /**
     * Default Destructor
     */
    virtual ~Krefty();

    /**
     * Use this method to load whatever file/URL you have
     */
    void load(const KURL& url);

    QString xslFile() { return m_xslFile; }

protected:
    /**
     * This method is called when it is time for the app to save its
     * properties for session management purposes.
     */
    void saveProperties(KConfig *);

    /**
     * This method is called when this app is restored.  The KConfig
     * object points to the session management config file that was saved
     * with @ref saveProperties
     */
    void readProperties(KConfig *);

private slots:
    void quit();
    //void fileNew();
    void fileOpen();
    void optionsShowToolbar();
    //void optionsShowStatusbar();
    //void optionsConfigureKeys();
    //void optionsConfigureToolbars();

    //void applyNewToolbarConfig();
    void slotComboChanged( const QString& name );

    void slotRefreshList();

private:
    void setupAccel();
    void setupActions();
    void setUpToolBar();
    int setupSheetList();
    bool checkSetup();
    bool copyStartUpFiles( KURL& userData );
    void setComboTo( QString sheetName );
    void openSheet( KURL url );

private:
    //KreftyPart *m_part;
    KParts::ReadOnlyPart* m_part;
    KreftySheetList* m_sheetList;
    KURL m_currentURL;
    QString m_dataDir;
    QString m_xslFile;

    KToggleAction *m_toolbarAction;
    KToggleAction *m_statusbarAction;

};

#endif // _KREFTY_H_
