/***************************************************************************
 *   Copyright (C) 2003 by jalal (Tim Pushman)                             *
 *   jalal@gnomedia.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef _KREFTYPART_H_
#define _KREFTYPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
//class KURL;
class KHTMLPart;
class KProcess;

const int HTML_VIEW_WIDTH = 650;

/**
 * This is a "Part".  It that does all the real work in a KPart
 * application.
 *
 * @short Main Part
 * @author jalal <jalal@supergnome>
 * @version 0.2
 */
class KreftyPart : public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    /**
     * Default constructor
     */
    KreftyPart(QWidget *parentWidget, const char *widgetName,
               QObject *parent, const char *name, const QStringList &args );

    /**
     * Destructor
     */
    virtual ~KreftyPart();

protected:
    /**
     * This must be implemented by each part
     */
    virtual bool openFile();

    void setXSLFile( const QString& fname ) { m_xslFile = fname; }

protected slots:
    void sheetLoaded();
    void transformDone( KProcess* );
    void htmlChunk(KProcess*, char*, int);
    void transformError(KProcess*, char* msg, int msglen );

private:
    KHTMLPart*      m_pHTMLPart;
    KProcess*       m_pProc;

    QWidget*        m_parentWidget;
    QStringList     m_args;
    QString         m_xslFile;
};

class KInstance;
class KAboutData;

class KreftyPartFactory : public KParts::Factory
{
    Q_OBJECT
public:
    KreftyPartFactory();
    virtual ~KreftyPartFactory();
    virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                            QObject *parent, const char *name,
                                            const char *classname, const QStringList &args );
    static KInstance* instance();

private:
    static KInstance* s_instance;
    static KAboutData* s_about;
};

#endif // _KREFTYPART_H_
