/***************************************************************************
 *   Copyright (C) 2003 by jalal (Tim Pushman)                             *
 *   jalal@gnomedia.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "krefty.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char *description =
    I18N_NOOP("A Quick Reference Application for KDE");

static const char *version = "0.2";

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    { 0, 0, 0 }
};

int main(int argc, char **argv)
{
    KAboutData about("krefty", I18N_NOOP("krefty"), version, description,
                     KAboutData::License_GPL, "(C) 2003 Tim Pushman", 0, 0, "jalal@gnomedia.com");
    about.addAuthor( "jalal", 0, "jalal@gnomedia.com" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;

    // see if we are starting with session management
    if (app.isRestored()) {
        RESTORE(Krefty);
    } else {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        if ( args->count() == 0 ) {
            Krefty *widget = new Krefty;
            widget->show();
        } else {
            int i = 0;
            for (; i < args->count(); i++ )  {
                Krefty *widget = new Krefty;
                widget->show();
                widget->load( args->url( i ) );
            }
        }
        args->clear();
    }
    return app.exec();
}
